$(document).ready(function() {
    resizeDOMHeights();

    cargarLlaves();
}); 

function delay(callback, ms) {
	var timer = 0;
	return function () {
		var context = this, args = arguments;
		clearTimeout(timer);
		timer = setTimeout(function () {
			callback.apply(context, args);
		}, ms || 0);
	};
}

// buscador por categorias
$("#buscador").on("keyup", function () {
	//console.log("2")
	var value = $(this).val().toLowerCase();
	$("#list_keys section").filter(function () {
		$(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
	});
});

function cargarLlaves(){
    $("#buscador").val("");
    $("#list_keys").empty();
    params = {
		service: "getLlaves",
		dbName: dbName,
		idEmpresas: localStorage.idEmpresas,
	};

	$("#loader").show();
    var keys = "";
    var switchs = "";
    var checked = "";
    var type_input = "";
	$.post(host, params, function (data) {

		$.each(data, function (key, val) {
            if (val.descripcion == null){
                val.descripcion = "";
            }

            checked = "";
            if(val.valor == "true"){
                checked = "checked";
            }else{
                checked = "";
            }  

            switch (val.valor){
                case "true":
                case "false":
                    type_input = "change";
                    switchs = `<div class="switch" style="margin:unset;">
                    <label>
                        <input id="${val.opcion}" type="checkbox" ${checked}>
                        <span class="lever"></span>
                    </label>
                    </div>`
                break;
                default:
                    type_input = "keyup";
                    switchs = `<div class="input-field col s12" style="margin:unset;">
                                <textarea id="${val.opcion}" style="margin:unset !important;">${val.valor}</textarea>
                            </div>`;
                    break;
            }

            keys += ` <section><div class="row" style="text-align: start;padding-left:30px;font-size: large;">
            <ul class="collection-item" onclick="">
                <div class="col s7" style="margin:unset;">
                    <div> <b>${val.opcion.toUpperCase()}:</b>  ${val.descripcion}</div>
                </div>
                <div class="col s5" style="margin:unset;text-align: start;">
                    ${switchs}
                </div>
            </div>
            </ul></section>`;
            localStorage.setItem(val.opcion, val.valor);
        });

    
        $("#list_keys").html(keys);

        $.each(data, function (key, val) {

            switch (val.valor){
                case "true":
                case "false":
                    $(`#${val.opcion}`).on("change", function () {
                        var opcion = $(`#${val.opcion}`).prop('checked');
                        guardarConfig(val.opcion, opcion);
                    });
                break;
                default:
                    $(`#${val.opcion}`).on("keyup", delay(function() {
                        var input = $(this).val();
                        if(input.length >= 1){
                            input = input.replace(/[_\W]+/g, " ");
                            guardarConfig(val.opcion, input);					
                        }
                    }, 1500));
                    break;
            }
        });
    },
    "json",
    ).done(function () {
        $("#loader").hide();
    });

}

function guardarConfig(opcion,valor){
    params = {
        service: "guardarConfig",
        dbName: dbName,
        idSucursales: localStorage.idSucursales,
        idUsuarios: localStorage.idUsuarios,
        idEmpresas: localStorage.idEmpresas,
        opcion: opcion,
        valor: valor
    };
    $.post(host, params, function (data) {
        $.each(data, function(key, val) {
            switch (val.message) {
                case 'success':
                    console.log("Saved!");
                    //SWAL
                    Swal.fire({
                        icon: 'success', text: "Cambio guardado!"
                    }).then(function () {        
                        window.location = "configuracion.html";
                        cargarLlaves();
                    });
                    break;
                default:
                    //SWAL
                    Swal.fire({
                        icon: 'error', text: "Error al guardar la configuracion, intente de nuevo"
                    }).then(function () {        
                        cargarLlaves();
                    });
                    break;
            }
        });
    }, "json").done(function () {
    });
}
